SystemOrganization addCategory: #'SBE-Quinto'!

TestCase subclass: #SBEGameTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGameTest methodsFor: 'as yet unclassified' stamp: 'on 5/8/2008 10:08'!
setUp
	game := SBEGame new.! !

!SBEGameTest methodsFor: 'as yet unclassified' stamp: 'on 5/8/2008 10:08'!
tearDown
	game delete.! !

!SBEGameTest methodsFor: 'as yet unclassified' stamp: 'on 5/8/2008 10:08'!
testNoError
	self shouldnt: [game openInWorld ] raise: Error.! !

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell methodsFor: 'initialization' stamp: 'apb 1/1/2007 18:55'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff
	! !

!SBECell methodsFor: 'accessing' stamp: 'apb 11/29/2006 14:43'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'apb 12/3/2006 01:08'!
mouseUp: anEvent
	(self containsPoint: Sensor mousePoint)  ifTrue: [mouseAction value]! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'on 11/17/2007 14:35' prior: 0!
A small game that shows you how to program mouse actions.

SBEGame new openInWorld!

!SBEGame methodsFor: 'initialization' stamp: 'apb 11/29/2006 22:19'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'apb 12/1/2006 16:50'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide..
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	bounds := (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j].! !

!SBEGame methodsFor: 'initialization' stamp: 'apb 12/2/2006 06:54'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropriate screen position.  Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'apb 11/29/2006 22:12'!
toggleNeighboursOfCellAt: i at: j 
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i  at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
